package Linode::Longview::DataGetter::Network;

use Exporter;
@ISA       = qw(Exporter);
@EXPORT_OK = qw(get);

use Linode::Longview::Util qw(slurp_file $procfs getLogger);

sub get {
	my (undef, $dataref) = @_;

	my $logger = getLogger();
	$logger->trace("Collecting network traffic info");

	my @data = slurp_file( $procfs . 'net/dev' ) or do {
		$logger->info("Couldn't read ${procfs}net/dev: $!");
		return $dataref;
	};

	foreach my $line (@data) {
		next unless $line =~ /^\s*.*?:/;
		$line =~ s/^\s*//;
		my ( $dev, $rx_bytes, $tx_bytes ) = ($line =~ /^\s*?(\S*?):\s*(\d+)(?:(\d+)|(\s+)){16}(\d+)/);
		next if ( $rx_bytes == 0 && $tx_bytes == 0 );
		$dev =~ s/:$//;
		$dev =~ s/\./\\\./g;

		# We need to "numify" these matches to make JSON::PP not-quote
		$dataref->{LONGTERM}->{"Network.Interface.$dev.rx_bytes"} = $rx_bytes + 0;
		$dataref->{LONGTERM}->{"Network.Interface.$dev.tx_bytes"} = $tx_bytes + 0;
	}
	return $dataref;
}

1;

