package Linode::Longview::DataGetter::Packages;

use Linode::Longview::DataGetter::Packages::APT;
use Linode::Longview::DataGetter::Packages::YUM;
use Linode::Longview::DataGetter::Packages::unknown;

use Linode::Longview::Util qw(getLogger);

use Exporter 'import';
our @EXPORT_OK = (qw(get));

sub get {
	my (undef, $dataref) = @_;
	
	my $logger = getLogger();
	$logger->trace("Collecting Package information");

	my $pkgTool = determinePkgTool($dataref);
	my $class = "Linode::Longview::DataGetter::Packages::${pkgTool}";
	my $ret = $class->get($dataref);
	return $ret;
}

sub determinePkgTool {
	my $dataref = shift;
	my $dist = $dataref->{INSTANT}->{"SysInfo.os.dist"};
	return 'APT' if ( $dist eq 'Debian' || $dist eq 'Ubuntu' );
	return 'YUM' if ( $dist eq 'Centos' || $dist eq 'Fedora' );
	return 'unknown';
}

1;
